/* --------------------------------------------------------------------- */

/*
 *  fec.h  --  FEC routines.
 *
 *  Copyright (C) 2000,2001,2002 Tomi Manninen (tomi.manninen@hut.fi)
 *
 *  This file is part of the NEWQPSK modem.
 *
 *  NEWQPSK modem is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  NEWQPSK modem is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* --------------------------------------------------------------------- */

#ifndef _FEC_H
#define _FEC_H

/* --------------------------------------------------------------------- */

struct fecstate {
	int feclevel;
	int bitbatchlen;
	int inlv;
	unsigned inlvpipe[MaxInlv * DataCarriers];
	unsigned inlvptr;
};

/* --------------------------------------------------------------------- */

extern inline void init_fec(struct fecstate *f)
{
	switch (f->feclevel) {
	case 0:
		f->bitbatchlen = 15;
		break;
	case 1:
		f->bitbatchlen = 11;
		break;
	case 2:
		f->bitbatchlen = 7;
		break;
	case 3:
		f->bitbatchlen = 5;
		break;
	}
}

/* --------------------------------------------------------------------- */

extern inline void init_inlv(struct fecstate *f)
{
        int i;

        for (i = 0; i < f->inlv * DataCarriers; i++)
                f->inlvpipe[i] = 0;
	f->inlvptr = 0;
}

/* --------------------------------------------------------------------- */

extern unsigned deinlv(struct fecstate *, unsigned);
extern unsigned inlv(struct fecstate *, unsigned);

extern unsigned fecencode(struct fecstate *, unsigned);
extern unsigned fecdecode(struct fecstate *, unsigned, unsigned *);

/* --------------------------------------------------------------------- */

#endif
