/* --------------------------------------------------------------------- */
 
/*
 *  newqpsktx.h  --  NEWQPSK transmit routines.
 *  
 *  Copyright (C) 2000,2001,2002 Tomi Manninen (tomi.manninen@hut.fi)  
 *  
 *  This file is part of the NEWQPSK modem.
 *      
 *  NEWQPSK modem is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  NEWQPSK modem is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *              
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* --------------------------------------------------------------------- */

#ifndef _NEWQPSKTX_H
#define _NEWQPSKTX_H

#include "complex.h"
#include "modemconfig.h"

/* --------------------------------------------------------------------- */

struct txstate {
	struct modemchannel *chan;
	struct fecstate fec;
	struct filter filt;
	unsigned int bps;
	unsigned int shreg;
	unsigned int bufsize;
	unsigned int tunelen;
	unsigned int synclen;
	void (*txroutine) (void *);
	int statecntr;
	int tuneonly;
	int txdone;
	int empty;
	float *txwindowfunc;
	complex tunevect[TuneCarriers];
	complex datavect[DataCarriers];
	unsigned txword[SymbolBits];
	complex txwin[WindowLen];
	complex fftbuf[WindowLen];
};

/* --------------------------------------------------------------------- */

extern void init_newqpsktx(void *);
extern int newqpsktx(void *, complex *);

/* --------------------------------------------------------------------- */

#endif
